*------------------------------------------------------------*;
* DMNeural: Create decision matrix;
*------------------------------------------------------------*;
data WORK.REP_hitel(label="REP_hitel");
  length   REP_hitel                        $  32
           COUNT                                8
           DATAPRIOR                            8
           TRAINPRIOR                           8
           DECPRIOR                             8
           DECISION1                            8
           DECISION2                            8
           ;

  infile   cards  dsd;

  input    REP_hitel $
           COUNT
           DATAPRIOR
           TRAINPRIOR
           DECPRIOR
           DECISION1
           DECISION2
           ;

  label    COUNT="Level Counts"
           DATAPRIOR="Data Proportions"
           TRAINPRIOR="Training Proportions"
           DECPRIOR="Decision Priors"
           DECISION1="1"
           DECISION2="0"
           ;
  informat REP_hitel $CHAR32.
           ;
cards;
1,3402,0.45960551202377,0.45960551202377,.,1,0
0,4000,0.54039448797622,0.54039448797622,.,0,1
;
run;
proc datasets lib=work nolist;
modify REP_hitel(type=PROFIT label=REP_hitel);
label DECISION1= "1";
label DECISION2= "0";
run;
quit;
*------------------------------------------------------------* ;
* DMNeural: DMDBClass Macro ;
*------------------------------------------------------------* ;
%macro DMDBClass;
    GRP_IMP_REP_ESNJ(ASC) GRP_REP_HNJE(ASC) REP_HEPTEL(ASC) REP_HKOMP(ASC)
   REP_HLAKA(ASC) REP_HLBER(ASC) REP_HLFUT(ASC) REP_HLGAZF(ASC) REP_HLHIT(ASC)
   REP_HLKTG(ASC) REP_HLKTR(ASC) REP_HLTIP(ASC) REP_HLTOR(ASC) REP_HLVIL(ASC)
   REP_HLVIZ(ASC) REP_HMEZFOL(ASC) REP_HMLAK(ASC) REP_HMOTOKC(ASC) REP_HUD(ASC)
   REP_SBISK1(ASC) REP_SBISK3(ASC) REP_SCSAL(ASC) REP_SCSAP(ASC) REP_SDOHE(ASC)
   REP_SGYOR(ASC) REP_SHAZTFO(ASC) REP_SKAVE(ASC) REP_SNEME(ASC)
   REP_TRA_HCTSZGA(ASC) REP_TRA_HMOTOKA(ASC) REP_TRA_HMOTOKB(ASC)
   REP_TRA_HMOTOKC(ASC) REP_TRA_HMOTOVA(ASC) REP_TRA_HMOTOVB(ASC)
   REP_TRA_HMOTOVC(ASC) REP_TRA_HSTSZGA(ASC) REP_TRA_HSTSZGB(ASC)
   REP_TRA_HSTSZGC(ASC) REP_hitel(DESC)
%mend DMDBClass;
*------------------------------------------------------------* ;
* DMNeural: DMDBVar Macro ;
*------------------------------------------------------------* ;
%macro DMDBVar;
    HLAKFT HLANM HLETS SZKOR TRA_HAERT
%mend DMDBVar;
*------------------------------------------------------------*;
* DMNeural: Create DMDB;
*------------------------------------------------------------*;
proc dmdb batch data=EMWS.BINNING_TRAIN dmdbcat=WORK.DMNeural_DMDB
maxlevel = 513
;
class %DMDBClass;
var %DMDBVar;
target
REP_hitel
;
run;
quit;
*------------------------------------------------------------* ;
* DMNeural: Input Variables Macro ;
*------------------------------------------------------------* ;
%macro INPUTS;
    GRP_IMP_REP_ESNJ GRP_REP_HNJE HLAKFT HLANM HLETS REP_HEPTEL REP_HKOMP
   REP_HLAKA REP_HLBER REP_HLFUT REP_HLGAZF REP_HLHIT REP_HLKTG REP_HLKTR
   REP_HLTIP REP_HLTOR REP_HLVIL REP_HLVIZ REP_HMEZFOL REP_HMLAK REP_HMOTOKC
   REP_HUD REP_SBISK1 REP_SBISK3 REP_SCSAL REP_SCSAP REP_SDOHE REP_SGYOR
   REP_SHAZTFO REP_SKAVE REP_SNEME REP_TRA_HCTSZGA REP_TRA_HMOTOKA REP_TRA_HMOTOKB
   REP_TRA_HMOTOKC REP_TRA_HMOTOVA REP_TRA_HMOTOVB REP_TRA_HMOTOVC REP_TRA_HSTSZGA
   REP_TRA_HSTSZGB REP_TRA_HSTSZGC SZKOR TRA_HAERT
%mend INPUTS;
proc dmneurl data=EMWS.BINNING_TRAIN dmdbcat=WORK.DMNeural_DMDB
outest=EMWS.DMNeural_ESTIMATE outfit=WORK._OUTFIT_DMNEURAL
out=WORK._OUT_DMNEURAL outclass=WORK._OUTCLASSDMNEURL_2BXODO1
optcrit=SSE maxcomp=3 maxstage=3 maxfunc=500
maxiter=200 maxvect=400 memsiz=8 stopr2=0.00005 cutoff=0.5 maxrows = 3000
absgconv=0.0005 gconv=1E-8
NOMONITOR
;
var %INPUTS;
target REP_hitel;
;
run;
