*------------------------------------------------------------*;
* Stat2: Computing Statistics for Interval Variables;
*------------------------------------------------------------*;
*------------------------------------------------------------* ;
* Stat2: STDIZE Variables Macro ;
*------------------------------------------------------------* ;
%macro stdizevar;
    ESNJ HAERT HCTSZGA HLAKFT HLANM HLETS HMOTOKB HMOTOVB HNJE HSTSZGB SZKOR
%mend stdizevar;
*------------------------------------------------------------*;
* Stat2: Computing Summary Statistics;
*------------------------------------------------------------*;
proc stdize
data = EMWS.Drop_TRAIN
out=_null_
outstat=WORK.Stat2INTERVAL
add=0 fuzz=1E-14 initial=MAD
vardef=df
method=STD
mult=1
pctlmtd=ORD_STAT pctldef=2
pctlpts=(
0
50
100
)
;
var %stdizevar;
run;
quit;
*------------------------------------------------------------*;
* Stat2: Computing Statistics for Interval Variables;
*------------------------------------------------------------*;
*------------------------------------------------------------* ;
* Stat2: STDIZE Variables Macro ;
*------------------------------------------------------------* ;
%macro stdizevar;
    ESNJ HAERT HCTSZGA HLAKFT HLANM HLETS HMOTOKB HMOTOVB HNJE HSTSZGB SZKOR
%mend stdizevar;
*------------------------------------------------------------*;
* Stat2: Computing Summary Statistics;
*------------------------------------------------------------*;
proc stdize
data = WORK.STATEXPLORE_TRAIN
out=_null_
outstat=WORK.Stat2INTERVAL
add=0 fuzz=1E-14 initial=MAD
vardef=df
method=STD
mult=1
pctlmtd=ORD_STAT pctldef=2
pctlpts=(
0
50
100
)
;
var %stdizevar;
run;
quit;
*------------------------------------------------------------*;
* Stat2: Computing Statistics for Interval Variables;
*------------------------------------------------------------*;
*------------------------------------------------------------* ;
* Stat2: STDIZE Variables Macro ;
*------------------------------------------------------------* ;
%macro stdizevar;
    ESNJ HAERT HCTSZGA HLAKFT HLANM HLETS HMOTOKB HMOTOVB HNJE HSTSZGB SZKOR
%mend stdizevar;
*------------------------------------------------------------*;
* Stat2: Computing Summary Statistics;
*------------------------------------------------------------*;
proc stdize
data = WORK.STATEXPLORE_TRAIN
out=_null_
outstat=WORK.Stat2INTERVAL
add=0 fuzz=1E-14 initial=MAD
vardef=df
method=STD
mult=1
pctlmtd=ORD_STAT pctldef=2
pctlpts=(
0
50
100
)
;
var %stdizevar;
run;
quit;
*------------------------------------------------------------*;
* Stat2: Computing Chi-Square Statistics;
*------------------------------------------------------------*;
ods listing close;
ods output chisq=WORK.TEMPCHISQUARE;
ods output crosstabFreqs=WORK.TEMPCROSSTAB;
proc freq data=EMWS.Drop_TRAIN order=formatted addnames;
table hitel*HAZON /chisq outexpect sparse;
table hitel*HEPTEL /chisq outexpect sparse;
table hitel*HKOMP /chisq outexpect sparse;
table hitel*HLAKA /chisq outexpect sparse;
table hitel*HLBER /chisq outexpect sparse;
table hitel*HLFUT /chisq outexpect sparse;
table hitel*HLGAZF /chisq outexpect sparse;
table hitel*HLHIT /chisq outexpect sparse;
table hitel*HLKTG /chisq outexpect sparse;
table hitel*HLKTR /chisq outexpect sparse;
table hitel*HLTIP /chisq outexpect sparse;
table hitel*HLTOR /chisq outexpect sparse;
table hitel*HLVIL /chisq outexpect sparse;
table hitel*HLVIZ /chisq outexpect sparse;
table hitel*HMEZFOL /chisq outexpect sparse;
table hitel*HMLAK /chisq outexpect sparse;
table hitel*HMOTOKC /chisq outexpect sparse;
table hitel*HMOTOVC /chisq outexpect sparse;
table hitel*HSTSZGC /chisq outexpect sparse;
table hitel*HUD /chisq outexpect sparse;
table hitel*SBISK1 /chisq outexpect sparse;
table hitel*SBISK3 /chisq outexpect sparse;
table hitel*SCSAL /chisq outexpect sparse;
table hitel*SCSAP /chisq outexpect sparse;
table hitel*SDOHE /chisq outexpect sparse;
table hitel*SFEOR /chisq outexpect sparse;
table hitel*SGYOR /chisq outexpect sparse;
table hitel*SHAZTFO /chisq outexpect sparse;
table hitel*SKAVE /chisq outexpect sparse;
table hitel*SNEME /chisq outexpect sparse;
;
run;
quit;
ods listing;
data WORK.Stat2CHI2(keep=TARGET INPUT CRAMERV CHIMEASURE PROBCHI CHIDF rename=(PROBCHI=PROB CHIDF=DF));
length TARGET INPUT $32;
label Target = "%sysfunc(sasmsg(sashelp.dmine, rpt_target_vlabel ,      NOQUOTE))" INPUT = "%sysfunc(sasmsg(sashelp.dmine, rpt_input_vlabel ,       NOQUOTE))" CRAMERV = "%sysfunc(sasmsg(sashelp.dmine, rpt_cramerv_vlabel ,     NOQUOTE))" CORRVALUE =
   "%sysfunc(sasmsg(sashelp.dmine, rpt_correlation_vlabel , NOQUOTE))" PROBCHI = "%sysfunc(sasmsg(sashelp.dmine, rpt_probchi_vlabel ,     NOQUOTE))" CHIMEASURE = "%sysfunc(sasmsg(sashelp.dmine, rpt_chisquare_vlabel,    NOQUOTE))" CHIDF =
   "%sysfunc(sasmsg(sashelp.dmine, rpt_df_vlabel ,          NOQUOTE))";
retain CHIMEASURE CHIDF PROBCHI;
format PROBCHI PVALUE6.4 CHIMEASURE 10.4;
set WORK.TEMPCHISQUARE;
Target = strip(RowVariable);
Input = strip(ColVariable);
where StatisticId in('_CRAMV_','_PCHI_');
if StatisticId = '_PCHI_' then do;
PROBCHI = Prob;
CHIMEASURE = VALUE;
CHIDF = DF;
end;
else do;
CRAMERV = abs(VALUE);
OUTPUT;
end;
run;
proc sort data=WORK.TEMPCROSSTAB;
by RowVariable ColVariable _Type_;
where _Type_ in('11','00');
run;
data WORK.Stat2CHI(keep=YVAR XVAR X Y XTEXT YTEXT COUNT CHISQUARE LOGCHISQUARE);
retain N;
dsid = open("WORK.TEMPCROSSTAB");
rowvarnum = varnum(dsid, 'RowVariable');
colvarnum = varnum(dsid, 'ColVariable');
freqnum = varnum(dsid, 'FREQUENCY');
rownum = varnum(dsid, 'RowPercent');
colnum = varnum(dsid, 'ColPercent');
typenum = varnum(dsid, '_TYPE_');
length YVAR XVAR $32 YTEXT $32 XTEXT $32;
do while(^fetch(dsid));
COUNT = getvarn(dsid, freqnum);
YVAR = (getvarc(dsid, rowvarnum));
XVAR = strip(getvarc(dsid, colvarnum));
ynum = varnum(dsid, YVAR);
ytype = vartype(dsid, ynum);
yformat = varfmt(dsid, ynum);
if yformat eq '' then yformat = 'best12.';
Y=.;
if ytype = 'N' then do;
Y = getvarn(dsid, ynum);
YTEXT = left(putn(Y, yformat));
end;
else YTEXT = getvarc(dsid, ynum);
xnum = varnum(dsid, XVAR);
xtype = vartype(dsid, xnum);
xformat = varfmt(dsid, xnum);
if xformat eq '' then xformat = 'best12.';
X=.;
if xtype = 'N' then do;
X = getvarn(dsid, xnum);
XTEXT = left(putn(X, xformat));
end;
else XTEXT = getvarc(dsid, xnum);
if getvarc(dsid, typenum)= '00' then N= count;
else do;
EXP = (getvarn(dsid,rownum)/100)*(getvarn(dsid,colnum)/100)*N;
if exp >0 then do;
CHISQUARE=(EXP-count)**2/(EXP);
if chisquare>0 then LOGCHISQUARE = log(CHISQUARE);
OUTPUT;
end;
end;
end;
dsid = close(dsid);
run;
